package tree;

import javax.swing.*;
import javax.swing.plaf.ColorUIResource;
import java.awt.*;

/**
 * @version 1.0 11/09/98
 */
class HyperLinkCell {
    private JLabel _icon;
    private TreeEditorPane _text;
    private final MyJPanel _jPanel = new MyJPanel();

    void setText(final String text) {
        _text.setText(text);
    }

    public MyJPanel getPanel() {
        return _jPanel;
    }

    HyperLinkCell() {

        _icon = new JLabel() {
            public void setBackground(Color color) {
                if (color instanceof ColorUIResource) {
                    color = null;
                }
                _jPanel.setBackground(color);
            }
        };

        _text = new TreeEditorPane();

        _jPanel.setIcon(_icon);
        _jPanel.setText(_text);
        _jPanel.setLayout(new BoxLayout(_jPanel, BoxLayout.X_AXIS));

        _jPanel.add(_icon);
        _jPanel.add(Box.createHorizontalStrut(4));

        _jPanel.add(_text);
    }

    public void setSelect(final boolean selected) {
        _text.setSelect(selected);
    }

    public void setEnabled(final boolean enabled) {
        _jPanel.setEnabled(enabled);
    }

    public void setIcon(final Icon icon) {
        _icon.setIcon(icon);
    }

    public Object getText() {
        return _text.getText();
    }

    void setFocus(final boolean hasFocus) {
        _text.setFocus(hasFocus);
    }
}
