package tree;

import javax.swing.*;
import javax.swing.tree.TreeCellEditor;
import java.awt.*;

/**
 * @version 1.0 11/09/98
 */
public class HyperLinkCellEditor extends AbstractCellEditor implements TreeCellEditor {
    private final HyperLinkCell _hyperLinkCell;

    public HyperLinkCellEditor() {
        _hyperLinkCell = new HyperLinkCell();
    }

    public Object getCellEditorValue() {
        return _hyperLinkCell.getText();
    }

    public Component getTreeCellEditorComponent(final JTree tree, final Object value, final boolean isSelected,
                                                final boolean expanded,
                                                final boolean leaf, final int row) {
        final String stringValue = value.toString();
        _hyperLinkCell.setEnabled(tree.isEnabled());
        _hyperLinkCell.setText(stringValue);
        _hyperLinkCell.setSelect(isSelected);
        if (leaf) {
            _hyperLinkCell.setIcon(UIManager.getIcon("Tree.leafIcon"));
        } else if (expanded) {
            _hyperLinkCell.setIcon(UIManager.getIcon("Tree.openIcon"));
        } else {
            _hyperLinkCell.setIcon(UIManager.getIcon("Tree.closedIcon"));
        }

        return _hyperLinkCell.getPanel();
    }
}
