package tree;

import javax.swing.*;
import javax.swing.tree.TreeCellRenderer;
import java.awt.*;

/**
 * @version 1.0 11/09/98
 */
public class HyperLinkCellRenderer extends HyperLinkCell implements TreeCellRenderer {
    public Component getTreeCellRendererComponent(final JTree tree, final Object value,
                                                  final boolean isSelected, final boolean expanded,
                                                  final boolean leaf, final int row, final boolean hasFocus) {
        final String stringValue = tree.convertValueToText(value, isSelected,
                expanded, leaf, row, hasFocus);
        setEnabled(tree.isEnabled());
        setText(stringValue);
        setSelect(isSelected);
        setFocus(hasFocus);
        if (leaf) {
            setIcon(UIManager.getIcon("Tree.leafIcon"));
        } else if (expanded) {
            setIcon(UIManager.getIcon("Tree.openIcon"));
        } else {
            setIcon(UIManager.getIcon("Tree.closedIcon"));
        }
        
        return getPanel();
    }
}
