package tree;

import javax.swing.*;
import javax.swing.tree.DefaultMutableTreeNode;
import java.awt.*;
import java.awt.event.MouseEvent;
import java.awt.event.MouseMotionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

public class HyperLinkTreeExample extends JFrame {
    public HyperLinkTreeExample() {
        super("Multi-Line JTree Example");

        final String[] strs = {"swing",              // 0
                "package",            // 1
                "<htlml><a href=\"bean::myBean\">java.awt.swing</a>"
                        + "com.sun.java.swing <a href=\"method::test\">test</a></html>", // 2
                "javax.swing",        // 3
                "JTree"};             // 4

        final DefaultMutableTreeNode[] nodes = new DefaultMutableTreeNode[strs.length];
        for (int i = 0; i < strs.length; i++) {
            nodes[i] = new DefaultMutableTreeNode(strs[i]);
        }
        nodes[0].add(nodes[1]);
        nodes[1].add(nodes[2]);
        nodes[1].add(nodes[3]);
        nodes[0].add(nodes[4]);

        final JTree tree = new JTree(nodes[0]);
        tree.setCellRenderer(new HyperLinkCellRenderer());
        tree.setCellEditor(new HyperLinkCellEditor());
        tree.setRowHeight(0);
        tree.setEditable(true);
        tree.setUI(new MyBasicTreeUI());
        tree.addMouseMotionListener(new MouseMotionListener() {
            public void mouseDragged(final MouseEvent e) {
            }

            public void mouseMoved(final MouseEvent e) {
                tree.startEditingAtPath(tree.getPathForLocation(e.getX(), e.getY()));
            }
        });

        final JScrollPane sp = new JScrollPane();
        sp.getViewport().add(tree);
        getContentPane().add(sp, BorderLayout.CENTER);
    }

    public static void main(final String[] args) {
        final HyperLinkTreeExample frame = new HyperLinkTreeExample();
        frame.addWindowListener(new WindowAdapter() {
            public void windowClosing(final WindowEvent e) {
                System.exit(0);
            }
        });
        frame.setSize(300, 150);
        frame.setVisible(true);
    }
}