package tree;

import javax.swing.*;
import javax.swing.plaf.ColorUIResource;
import java.awt.*;

class MyJPanel extends JPanel {
    private JLabel _icon;
    private TreeEditorPane _text;

    public void setIcon(final JLabel icon) {
        _icon = icon;
    }

    public void setText(final TreeEditorPane text) {
        _text = text;
    }

    public Dimension getPreferredSize() {
        if (_icon == null || _text == null) {
            return null;
        }
        final Dimension iconD = _icon.getPreferredSize();
        final Dimension textD = _text.getPreferredSize();
        final int height = iconD.height < textD.height ?
                textD.height : iconD.height;
        return new Dimension(iconD.width + textD.width + 2, height);
    }

    public void setBackground(Color color) {
        if (color instanceof ColorUIResource) {
            color = null;
        }
        super.setBackground(color);
    }
}
